//var utils    = require( '../utils' );
var mongoose = require( 'mongoose' );
var Rmaster     = mongoose.model( 'Rmaster' );
var Rtrans     = mongoose.model( 'Rtrans' );

exports.register = function ( req, res, next ) {
  var mobile = req.params.mobile ?
    req.params.mobile : undefined;
  var out = []; 
  Rmaster.
    findOne({ mobile : mobile }).
    exec( function ( err, rmaster ){

	  res.setHeader('access-control-allow-origin', '*');
	  res.setHeader('access-control-allow-methods', 'GET, POST, PUT, DELETE, OPTIONS, JSONP');
	  res.setHeader('access-control-allow-headers', 'content-type, accept');
	  res.setHeader('access-control-max-age', 10);
	
	  if(err || !rmaster) {
		      console.log("registering.." + req.params.mobile);
			  new Rmaster({
				  mobile    : req.params.mobile,
				  totalamount    : 0,
				  created_at : Date.now()
			  }).save( function (err, newres){
			      res.json(newres);
			  });
	  }	else {
		  console.log("already exits.." + req.params.mobile);
		  res.json(rmaster);
	  }
	
	});
};

exports.buyticket = function ( req, res, next ) {

  if (req.params.amount) {
      
	  res.setHeader('access-control-allow-origin', '*');
	  res.setHeader('access-control-allow-methods', 'GET, POST, PUT, DELETE, OPTIONS, JSONP');
	  res.setHeader('access-control-allow-headers', 'content-type, accept');
	  res.setHeader('access-control-max-age', 10);
	
		 Rmaster.
			findOne({ mobile : req.params.mobile }).
			exec( function ( err, rmaster ){

				  var checkamt = Number(rmaster.totalamount) - Number(req.params.amount);
				  if (checkamt > 0) {
						  new Rtrans({
							  mobile    : req.params.mobile,
							  spent    : req.params.amount,
							  created_at : Date.now()
						  }).save( function ( err, trans, count ) {
						
								rmaster.mobile =  req.params.mobile;
								rmaster.totalamount = Number(rmaster.totalamount) - Number(req.params.amount);
								rmaster.save(function (err, newres) {
									  console.log(newres);
									  res.json(newres);
								});
								
						  });
				  } else {
				     res.json([]);	 
				  }

		 });
		 
  }	else {
     res.json([]);	 
  }
  
};

exports.buypackage = function ( req, res, next ) {
    Rmaster.
    findOne({ mobile : req.params.mobile }).
    exec( function ( err, rmaster ){

	  res.setHeader('access-control-allow-origin', '*');
	  res.setHeader('access-control-allow-methods', 'GET, POST, PUT, DELETE, OPTIONS, JSONP');
	  res.setHeader('access-control-allow-headers', 'content-type, accept');
	  res.setHeader('access-control-max-age', 10);
	
	  if(err || !rmaster) {
		    res.json([]);  
	  }	else {
			

			var paypal_sdk = require('paypal-rest-sdk');
			 
			paypal_sdk.configure({
			'mode': 'sandbox', //sandbox or live
				'client_id': 'EBWKjlELKMYqRNQ6sYvFo64FtaRLRR5BdHEESmha49TM',
				'client_secret': 'EO422dn3gQLgDbuwqTjzrFgFtaRLRR5BdHEESmha49TM'
			});

			var card_data = {
				"type": req.params.type,
				"number": req.params.cardnumber,
				"expire_month": req.params.month,
				"expire_year": req.params.year,
				"cvv2": req.params.cvv,
				"first_name": req.params.firstname,
				"last_name": req.params.lastname
			};
			 
			var create_payment_json = {
				"intent": "sale",
				"payer": {
					"payment_method": "credit_card",
					"funding_instruments": [{
						"credit_card": card_data
					}]
				},
				"transactions": [{
					"amount": {
						"total": req.params.package,
						"currency": "USD"
					},
					"description": "This is the payment transaction description."
				}]
			};

			/*var config_options = {
			'host': 'api.sandbox.paypal.com',
			'port': '',
			'client_id': 'EBWKjlELKMYqRNQ6sYvFo64FtaRLRR5BdHEESmha49TM',
			'client_secret': 'EO422dn3gQLgDbuwqTjzrFgFtaRLRR5BdHEESmha49TM'
			};*/

			paypal_sdk.payment.create(create_payment_json, function (err, payment) {
				if (err) {
					res.json([]);
				} else {
					if (payment){
						rmaster.mobile =  req.params.mobile;
						rmaster.totalamount = Number(rmaster.totalamount) + Number(req.params.package);
						rmaster.save( function (err, newres){
							  console.log(rmaster);
							  res.json(newres);
						});
					}
				}
			});

			/*paypal_sdk.credit_card.create(card_data, config_options, function(err , cardres){
				if (err){
					res.json([]);
				}
				
				if (cardres){
					rmaster.mobile =  req.params.mobile;
					rmaster.totalamount = rmaster.totalamount + req.params.package;
					rmaster.save( function (err, newres){
						  console.log(rmaster);
						  res.json(newres);
					});
				}
			});	  */

	  }	// end of if
	
	});
};